;--------------------------------------------------------------------
; 4/28/86
; Written by Lansing Pugh, Architect
;
; This is a scraggly LISP routine that will read in a strictly
; formatted text file describing the metes and bounds of a piece of
; land and draw the lines into an AutoCAD drawing.
;
; The text file must be formatted like this:
;
; 12
; N 89 52 00 E 1996.4
; S 00 22 00 W 952.8
; S 01 07 00 E 1134.2
; N 84 10 00 W 643.0
; N 80 23 00 W 573.9
; N 03 13 00 E 274.4
; N 00 45 00 W 35.5
; N 26 05 00 W 73.5
; N 35 01 00 W 1309.5
; N 17 42 00 W 62.0
; N 09 18 00 W 94.5
; N 00 04 00 E 320.3
;
; where the first line in the file is the number of lines.  Note the
; need for place-holder characters, even in the seconds column, which
; is useable if your survey is that detailed.
;
; Limited as this routine is (no arcs, no labeling, etc.), I have
; found it good enough to save me time when I start a site plan and
; want to quickly enter accurate boundaries.
;
; ps. Note that a circle with a radius of 2 is drawn at each intersection.
;     Change that value if you'd like.
;
;
; You are welcome to use this code in any way you see fit.  Just
; don`t blame me if it doesn't work.
;
;--------------------------------------------------------------------

(defun C:COGODRAW ()
   (cogogetname)
   (drawlines)
   (close f)
   (setvar "CMDECHO" 1)
)

(defun cogogetname ()
  (print "")
  (setq filename (getstring "Name the cogo data file you want to draw: "))
  (setq f (open filename "r"))
)

(defun drawlines ()

(terpri)
(SETQ STARTPOINT (GETPOINT "Enter starting location for plot: "))
(SETVAR "CMDECHO" 0)
(terpri)
(setq n (atoi(read-line f)))		   ;see how many lines in file

;MAIN LOOP
  (repeat n  (setq data (read-line f))

;PARSE THE DATA LINE

(setq direction (strcat (substr data 1 1) (substr data 12 1)))
(if (equal "NE" direction) (setq deltadeg 90))
(if (equal "NW" direction) (setq deltadeg 90))
(if (equal "SW" direction) (setq deltadeg 270))
(if (equal "SE" direction) (setq deltadeg 270))
(if (equal "NE" direction) (setq sign -1))
(if (equal "NW" direction) (setq sign 1))
(if (equal "SW" direction) (setq sign -1))
(if (equal "SE" direction) (setq sign  1))

(SETQ DEGREES (atof (strcat (substr data 3 1)(substr data 4 1))))
(SETQ MINUTES (atof (strcat (substr data 6 1)(substr data 7 1))))
(SETQ SECONDS (atof (strcat (substr data 9 1)(substr data 10 1))))
(SETQ BEARING (+ DEGREES (/ MINUTES 60) (/ SECONDS 3600)))
(SETQ BEARING (+ (* BEARING SIGN) DELTADEG))

(SETQ DIST (atof (substr data 14)))

(SETQ BEARING (/ BEARING (/ 360 (* 2 PI))))
(SETQ ENDPOINT (POLAR STARTPOINT BEARING DIST))
(command "LINE" STARTPOINT ENDPOINT)
(command "")
(COMMAND "CIRCLE" STARTPOINT 2)
(setq startpoint endpoint)
)	       ;end of loop
)	       ;end of drawlines
